//+------------------------------------------------------------------+
//|                                                  VininE Game.mq4 |
//|                      Copyright  2008, Victor Nicolaev aka Vinin |
//|                                           skype: victor.nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+

//   ""  



#property copyright "Copyright  2008 Victor Nicolaev"
#property link      "vinin@mail.ru"


extern double Lots = 0.1;
extern double MaximumRisk=5.0;
extern int cmd=OP_BUY;
extern int TP=200;
extern int SL=200;
extern int MagicNumber = 0;            

string  _comment       = "VininE_Game_1_AC";           //  

color   clOpenBuy      = Red; 
color   clOpenSell     = Blue;
color   clCloseBuy     = Red; 
color   clCloseSell    = Blue;

int Order_Count[6];


string   NameOP[]={"BUY","SELL","BUYLIMMIT","SELLLIMIT","BUYSTOP","SELLSTOP"};

#include <stdlib.mqh>
#include <WinUser32.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()  {
   return(0);
}
int deinit() {return(0);}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   static int prevtime=0;
   if(iTime(Symbol(),PERIOD_D1,0) == prevtime)  return(0);
   prevtime = iTime(Symbol(),PERIOD_D1,0);
   
   int cmd=Signal();
   if (cmd==-1) return(0);
   SetOrder(cmd);
   return(0);
}

int Signal(){
   double tmp1=iAC(NULL,0,1);
   double tmp2=iAC(NULL,0,2);
   if (tmp1>0 && tmp2<=0) return(OP_BUY);
   if (tmp1<0 && tmp2>=0) return(OP_SELL);

   return(-1);
}

double iif(bool a, double b, double c){if(a) return(b);return(c);}


bool SetOrder(int OP){
   bool Res=false;
   int cmd=MathAbs(OP-1);
   Order_Count_Calculate();          //      
   if (Order_Count[cmd]>0)             //    
      Order_Close(cmd);
   if (Order_Count[OP]==0)             //    
      Order_Open( OP);
   return(Res);
}

//===============================================================================
//          
//===============================================================================
int Order_Count_Calculate(int OP=-1){
   ArrayInitialize(Order_Count,0);
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))   continue;
      if (OrderSymbol() != Symbol())                     continue;
      if (OrderMagicNumber() != MagicNumber)                   continue;
      if (OrderType()!=OP && OP!=-1)                     continue;
      Order_Count[OrderType()]++;
   }
   if (OP!=-1) return(Order_Count[OP]);
}

void Order_Close(int OP=-1){
   bool res;
   GetLastError();
   for(int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))   continue;
      if (OrderSymbol() != Symbol())                     continue;
      if (OrderMagicNumber() != MagicNumber)             continue;
      if (OrderType()!=OP && OP!=-1)                     continue;
      
      RefreshRates();
      
      double _ask      =MarketInfo(Symbol(),MODE_ASK);
      double  _bid     =MarketInfo(Symbol(),MODE_BID);
      double  _point   =MarketInfo(Symbol(),MODE_POINT);
      double  _digits  =MarketInfo(Symbol(),MODE_DIGITS);
      double ClosePrice=NormalizeDouble(iif(OrderType()==OP_BUY,_bid, _ask),_digits);
      res=OrderClose(OrderTicket(), OrderLots(), ClosePrice, 3, iif(OrderType()==OP_BUY,clCloseBuy,clCloseSell));
      if (!res) {
         int err=GetLastError();
         Print("Error(",err,") delete order ",NameOP[OP],": ",ErrorDescription(err));
      }
   }
}

//======================================================================================================
//   
//=====================================================================================================
void Order_Open(int OP){
   int err=GetLastError();
   RefreshRates();

   int cmd=iif(OP==OP_BUY,1,-1);
   double _ask     =MarketInfo(Symbol(),MODE_ASK);
   double _bid     =MarketInfo(Symbol(),MODE_BID);
   double _point   =MarketInfo(Symbol(),MODE_POINT);
   double _digits  =MarketInfo(Symbol(),MODE_DIGITS);
   double price= iif(OP==OP_BUY==0,_ask,_bid);
   double _sl=NormalizeDouble(iif(SL==0,0,price-cmd*SL*_point),_digits);
   double _tp=NormalizeDouble(iif(TP==0,0,price+cmd*TP*_point),_digits);
   double lots=GetLots();      

   OrderSend(Symbol(), OP,  lots, price, 3,_sl,_tp,_comment,MagicNumber, 0); 
   err=GetLastError();
   if (err>0) Print(Ask," ;", Bid, " ;", price," ;",_sl," ;",_tp);

}

//===============================================================================
//         
//
//===============================================================================
double GetLots() {
   double LotMin=MarketInfo(Symbol(),MODE_MINLOT);
   double LotMax=MarketInfo(Symbol(),MODE_MAXLOT);
   double LotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot=MathRound(Lots/LotStep)*LotStep;
   if (MaximumRisk>0) {
      lot = MathRound(AccountFreeMargin() * MaximumRisk / 100000.0/LotStep)*LotStep; 
   }
   
   
   lot=MathMax(LotMin,MathMin(LotMax,lot));
   
   return(lot); 
}